; Advanced Action Movie Simulator
; Pure blasphemy by Cadaver for CGC2001

                processor 6502
                org $0800

JOY_UP          = 1
JOY_DOWN        = 2
JOY_LEFT        = 4
JOY_RIGHT       = 8
JOY_FIRE        = 16

textptrlo       = $02
textptrhi       = $03
temp1           = $04
temp2           = $05
temp3           = $06
temp4           = $07
temp5           = $08
temp6           = $09
temp7           = $0a
temp8           = $0b
textcolor       = $0c

textscreen      = $0400
sprites         = $2000
music           = $4000
colors          = $d800

start:          jsr initpanel
                jsr initvideo
                jsr initirq
title:          lda #$00
                jsr cleartextscreen
                lda #15
                sta textcolor
                lda #<text1
                sta textptrlo
                lda #>text1
                sta textptrhi
                ldy #4
                jsr printtextc
                lda #7
                sta textcolor
                ldy #7
                jsr printtextc
                lda #1
                sta textcolor
                ldy #10
                jsr printtextc

                jsr waitfire

gamebegin:      lda #0
                sta level
                sta score+0
                sta score+1
                sta score+2
                lda #20
                sta delayvalue

levelbegin:     lda #128
                sta energy
                ldx level
                cpx #$04
                bcs skiplevelinit
                lda #128
                sta dist,x
skiplevelinit:  lda #$00
                jsr cleartextscreen
                jsr initpanel
                lda level
                asl
                tax
                lda briefingptr,x
                sta textptrlo
                lda briefingptr+1,x
                sta textptrhi
                ldy #5
                lda #1
                sta textcolor
                jsr printtextc
                lda #7
                sta textcolor
                iny
                iny
                jsr printtextc
                iny
                jsr printtextc
                iny
                jsr printtextc
                iny
                iny
                lda #<continuetext
                sta textptrlo
                lda #>continuetext
                sta textptrhi
                lda #15
                sta textcolor
                jsr printtextc

                jsr waitfire

                lda level
                asl
                tax
                lda leveljumptbl,x
                sta leveljump+1
                lda leveljumptbl+1,x
                sta leveljump+2
leveljump:      jmp $0000

gameover:       lda #$00
                jsr cleartextscreen
                lda #7
                sta textcolor
                ldy #9
                lda #<gameovertext
                sta textptrlo
                lda #>gameovertext
                sta textptrhi
                jsr printtextc
                lda #$06
                jsr longdelay

                lda score+1
                cmp hiscore+1
                beq gameover_checklow
                bcs gameover_newhiscore
                bcc gameover_nohiscore
gameover_checklow:
                lda score
                cmp hiscore
                bcc gameover_nohiscore
gameover_newhiscore:
                lda score
                sta hiscore
                lda score+1
                sta hiscore+1
                lda score+2
                sta hiscore+2
gameover_nohiscore:
                jsr updatepanel
                jmp title

carchase:       lda #$00
                sta roadcounter
                jsr cleartextscreen
                ldx #19
cc_fillscreen:  jsr cc_drawroad
                dex
                bpl cc_fillscreen

                jsr clearsprites

                lda #112                ;Init player car
                sta spritex
                lda #128
                sta spritey
                lda #11
                sta spritec
                lda #128
                sta spritef
                lda #$00
                sta spritesx
                sta spritesy

                lda #$ff
                sta $d017               ;Y-expand for all sprites
                lda #$00
                sta $d01d

cc_mainloop:    jsr getcontrols

                ldx #$07                ;Animation of sprites
cc_animloop:    lda spritef,x
                beq cc_animskip
                lda spritef,x           ;Tire animation
                cmp #132                ;Police car?
                bcs cc_policeanim
                eor #$01
                sta spritef,x
                jmp cc_animok
cc_policeanim:  sec
                sbc #132
                clc
                adc #$01
                and #$03
                tay
                clc
                adc #132
                sta spritef,x
                lda policecarcolortbl,y
                sta spritec,x
cc_animskip:
cc_animok:      dex
                bpl cc_animloop


                lda joystick            ;Acceleration of player car
                and #JOY_UP
                beq cc_notup
                dec spritesy
cc_notup:       lda joystick
                and #JOY_DOWN
                beq cc_notdown
                inc spritesy
cc_notdown:     lda joystick
                and #JOY_LEFT
                beq cc_notleft
                dec spritesx
cc_notleft:     lda joystick
                and #JOY_RIGHT
                beq cc_notright
                inc spritesx
cc_notright:

                jsr movesprites

                lda spritey             ;Player bounds checking
                cmp #50                 ;(vertical)
                bcs cc_yok1
                lda #50
                sta spritey
                lda #$00
                sta spritesy
cc_yok1:        lda spritey
                cmp #160+50-42
                bcc cc_yok2
                lda #160+50-42
                sta spritey
                lda #$00
                sta spritesy
cc_yok2:

                ldx #$00                ;Background collision
                jsr getcharundersprite
                cmp #$a0
                beq cc_bgok
                lda #$03
                jsr plrdamage
cc_bgok:

                ldx #$00                ;Scoring & level progress
                ldy #$05
                jsr addscore
                inc distcounter
                lda distcounter
                cmp #$07
                bcc cc_nodist
                lda #$00
                sta distcounter
                dec dist
cc_nodist:

                jsr random              ;Creating enemies
                cmp #$0a
                bcs cc_nonewenemy
                ldx #$07                ;Search for a free enemy
cc_searchfreeenemy:
                lda spritef,x
                beq cc_freeenemyfound
                dex
                bne cc_searchfreeenemy
                jmp cc_nonewenemy
cc_freeenemyfound:
                lda #160+50-42
                sta spritey,x
                jsr random
                and #63
                clc
                adc #60
                sta spritex,x
                jsr random
                and #$03
                clc
                adc #-7
                sta spritesy,x
                lda #0
                sta spritesx,x
                jsr random                      ;Villain or police?
                and #$01
                tay
                lda enemyframetbl,y
                sta spritef,x
                lda enemycolortbl,y
                sta spritec,x
cc_nonewenemy:

                ldx #$07                        ;Check for remove of too far
cc_removeenemyloop:                             ;enemies
                lda spritef,x
                beq cc_removeenemyskip

                lda spritex,x
                sec
                sbc spritex
                bpl cc_xcollok
                eor #$ff
                adc #$01
cc_xcollok:     cmp #12
                bcs cc_nocollision
                lda spritey,x
                sec
                sbc spritey
                bpl cc_ycollok
                eor #$ff
                adc #$01
cc_ycollok:     cmp #42
                bcs cc_nocollision
                lda #$02
                jsr plrdamage
cc_nocollision:
                lda spritey,x
                cmp #50-21
                bcc cc_removeenemy
                lda spritey,x
                cmp #160+50+21
                bcc cc_removeenemyskip
cc_removeenemy: lda #$00
                sta spritef,x
cc_removeenemyskip:
                dex
                bne cc_removeenemyloop

                jsr cc_scrollup
                ldx #0
                jsr cc_drawroad
                jsr drawsprites
                jsr updatepanel
                jsr delay

                lda energy              ;Energy zero?
                beq cc_death
                lda dist                ;Level completed?
                beq cc_complete
                jmp cc_mainloop

cc_death:       inc spritec
                jsr drawsprites
                jsr updatepanel
                ldy #$02
                jsr fixeddelay
                lda spritec
                bne cc_death
                jmp gameover

cc_complete:    jsr countenergybonus
                jmp nextlevel

cc_scrollup:    lda #<(textscreen+18*40)
                sta temp1
                lda #>(textscreen+18*40)
                sta temp2
                lda #<(colors+18*40)
                sta temp3
                lda #>(colors+18*40)
                sta temp4
                lda #<(textscreen+19*40)
                sta temp5
                lda #>(textscreen+19*40)
                sta temp6
                lda #<(colors+19*40)
                sta temp7
                lda #>(colors+19*40)
                sta temp8
                ldy #$00
cc_scrollloop:  lda (temp1),y
                sta (temp5),y
                lda (temp3),y
                sta (temp7),y
                iny
                cpy #40
                bne cc_scrollloop
                ldy #$00
                lda temp1
                sec
                sbc #40
                sta temp1
                sta temp3
                bcs cc_temp1ok
                dec temp2
                dec temp4
cc_temp1ok:     lda temp5
                sec
                sbc #40
                sta temp5
                sta temp7
                bcs cc_temp2ok
                dec temp6
                dec temp8
cc_temp2ok:     lda temp1
                cmp #<(textscreen-40)
                bne cc_scrollloop
                lda temp2
                cmp #>(textscreen-40)
                bne cc_scrollloop
                rts

cc_drawroad:    txa
                pha
                lda screenrowtbllo,x
                sta temp1
                sta temp3
                lda screenrowtblhi,x
                ora #>textscreen
                sta temp2
                lda screenrowtblhi,x
                ora #>colors
                sta temp4
                ldy #0
cc_dr1:         jsr random
                and #$03
                tax
                lda grasscolortbl,x
                sta (temp3),y
                jsr random
                and #$03
                tax
                lda grasschartbl,x
                sta (temp1),y
                iny
                cpy #10
                bcc cc_dr1
cc_dr3:         lda #12
                sta (temp3),y
                lda #$a0
                sta (temp1),y
                iny
                cpy #30
                bcc cc_dr3
                inc roadcounter
                lda roadcounter
                and #$04
                beq cc_drskip
                lda #1
                ldy #20
                sta (temp3),y
cc_drskip:      ldy #30
cc_dr2:         jsr random
                and #$03
                tax
                lda grasscolortbl,x
                sta (temp3),y
                jsr random
                and #$03
                tax
                lda grasschartbl,x
                sta (temp1),y
                iny
                cpy #40
                bcc cc_dr2
                pla
                tax
                rts

grasscolortbl:  dc.b $05,$03,$0d,$05
grasschartbl:   dc.b $7f,$a0,$6f,$6c
policecarcolortbl:dc.b 14,14,10,10
enemyframetbl:  dc.b 130,132
enemycolortbl:  dc.b 2,14







gunfight:       lda #$09
                jsr cleartextscreen
                jsr clearsprites

                ldx #150
gf_makeground:  jsr random
                and #31
                cmp #20
                bcs gf_makeground
                tay
                lda screenrowtbllo,y
                sta temp1
                lda screenrowtblhi,y
                ora #>textscreen
                sta temp2
gf_makeground2: jsr random
                and #63
                cmp #40
                bcs gf_makeground2
                tay
                lda #174
                sta (temp1),y
                dex
                bne gf_makeground

                lda #86
                sta spritex
                lda #109
                sta spritey
                lda #10
                sta spritec
                lda #136
                sta spritef
                lda #0
                sta sprited

                lda #$ff
                sta $d017               ;Y-expand for all sprites
                lda #$00
                sta $d01d

gf_mainloop:    jsr getcontrols

                lda #0                          ;Assume: player stationary
                sta spritesx
                sta spritesy
                lda joystick
                and #JOY_RIGHT
                beq gf_notright
                lda #2
                sta spritesx
                lda #0
                sta sprited
gf_notright:    lda joystick
                and #JOY_LEFT
                beq gf_notleft
                lda #-2
                sta spritesx
                lda #2
                sta sprited
gf_notleft:     lda joystick
                and #JOY_DOWN
                beq gf_notdown
                lda #2
                sta spritesy
                lda #1
                sta sprited
gf_notdown:     lda joystick
                and #JOY_UP
                beq gf_notup
                lda #-2
                sta spritesy
                lda #3
                sta sprited
gf_notup:       lda spritesx
                ora spritesy
                beq gf_skipplranim
                ldy sprited
                lda spritef
                eor #$01
                and #$01
                ora plrframetbl,y
                sta spritef
gf_skipplranim: lda joystick
                and #JOY_FIRE
                beq gf_noplrshoot
                lda spritef+1                   ;Shot already active?
                bne gf_noplrshoot
                lda spritex
                sta spritex+1
                lda spritey
                sta spritey+1
                lda #1
                sta spritec+1
                lda #152
                sta spritef+1
                lda #25
                sta spritet+1
                ldy sprited
                lda bltspeedtblx,y
                sta spritesx+1
                lda bltspeedtbly,y
                sta spritesy+1

gf_noplrshoot:
                lda spritef+1                   ;Player bullet active?
                beq gf_skipplrbullet
                dec spritet+1                   ;Decrease its time
                bne gf_skipplrbullet
                lda #0
                sta spritef+1
gf_skipplrbullet:

                lda spritef+2                   ;Enemy bullet active?
                beq gf_skipenemybullet
                ldx #2
                ldy #0
                jsr checkbulletcollision
                bcs gf_noplrcollision
                lda #0
                sta spritef+2
                lda #24
                jsr plrdamage
gf_noplrcollision:
                dec spritet+2                   ;Decrease its time
                bne gf_skipenemybullet
                lda #0
                sta spritef+2
gf_skipenemybullet:

                jsr random                      ;New enemy creation?
                cmp #$0a
                bcs gf_skipnewenemy
                ldx #$07
gf_findemptyenemy:
                lda spritef,x
                beq gf_emptyfound
                dex
                cpx #$03
                bcs gf_findemptyenemy
                jmp gf_skipnewenemy
gf_emptyfound:  jsr random
                sta spritex,x
                lda #5
                sta spritec,x
                jsr random
                and #$03
                sta sprited,x
                tay
                lda enemy2frametbl,y
                sta spritef,x
                jsr random
                and #$7f
                adc #60
                sta spritey,x
                jsr random
                and #$1f
                adc #10
                sta spritet,x
                lda #$00
                sta spritesx,x
                sta spritesy,x
gf_skipnewenemy:

                ldx #$07                        ;Movement of enemies
gf_enemymoveloop:
                lda spritef,x
                bne gf_enemyok
                jmp gf_skipenemy
gf_enemyok:     lda spritef+1                   ;Player bullet active?
                beq gf_skipenemybltcoll
                ldy #1
                jsr checkbulletcollision
                bcs gf_skipenemybltcoll
                txa
                pha
                ldx #$02
                ldy #$50
                jsr addscore
                lda enemy
                sec
                sbc #$04
                sta enemy
                lda #0
                sta spritef+1
                pla
                tax
                lda #0
                sta spritef,x
                jmp gf_skipenemy
gf_skipenemybltcoll:
                dec spritet,x
                bne gf_enemynonewdir
                jsr random
                and #$03
                sta sprited,x
                jsr random
                and #$1f
                adc #10
                sta spritet,x
gf_enemynonewdir:
                ldy sprited,x
                lda spritef,x
                and #$01
                eor #$01
                ora enemy2frametbl,y
                sta spritef,x
                lda enemyspeedtblx,y
                sta spritesx,x
                lda enemyspeedtbly,y
                sta spritesy,x
                jsr random
                cmp #$10
                bcs gf_enemyskipshoot

                lda spritef+2                   ;Shot already active?
                bne gf_enemyskipshoot
                lda spritex,x
                sta spritex+2
                lda spritey,x
                sta spritey+2
                lda #1
                sta spritec+2
                lda #152
                sta spritef+2
                lda #25
                sta spritet+2
                lda bltspeedtblx,y
                sta spritesx+2
                lda bltspeedtbly,y
                sta spritesy+2

gf_enemyskipshoot:
gf_skipenemy:
                dex
                cpx #$03
                bcc gf_enemiesdone
                jmp gf_enemymoveloop

gf_enemiesdone: jsr movesprites

                ldx #$07                ;Handle wrapping of all sprites
gf_checkspritewrap:
                lda spritef,x
                beq gf_spritewrapok2
                lda spritey,x
                cmp #50-21
                bcs gf_spritewrapok1
                lda #50+160-42
                sta spritey,x
                jmp gf_spritewrapok2
gf_spritewrapok1:
                lda spritey,x
                cmp #50+161-42
                bcc gf_spritewrapok2
                lda #50-21
                sta spritey,x
gf_spritewrapok2:
                dex
                bpl gf_checkspritewrap

                jsr drawsprites
                jsr updatepanel
                ldy #$05
                jsr fixeddelay
                jsr delay
                lda energy
                beq gf_death
                lda enemy
                beq gf_complete
                jmp gf_mainloop

gf_death:       inc spritec
                jsr drawsprites
                jsr updatepanel
                ldy #$02
                jsr fixeddelay
                lda spritec
                bne gf_death
                jmp gameover

gf_complete:    jsr countenergybonus
                jmp nextlevel

plrframetbl:    dc.b 136,138,140,142
enemy2frametbl:  dc.b 144,146,148,150
bltspeedtblx:   dc.b 4,0,-4,0
bltspeedtbly:   dc.b 0,4,0,-4
enemyspeedtblx: dc.b 2,0,-2,0
enemyspeedtbly: dc.b 0,2,0,-2







romance:        lda #$06
                jsr cleartextscreen
                jsr clearsprites
                lda #$ff
                sta $d017               ;Y & X-expand for all sprites
                sta $d01d

                lda #10
                sta spritec
                sta spritec+1
                lda #44
                sta spritex
                lda #112
                sta spritex+1
                lda #104
                sta spritey
                lda #80
                sta spritey+1
                lda #153
                sta spritef
                lda #155
                sta spritef+1
                lda #JOY_LEFT
                sta heronextmove

                lda #0
                sta heromouth
                sta heroidle
                sta herostringptr
                sta womanmouth
                sta womanidle
                sta womantime
                sta womanstringptr
                sta timecounter

r_mainloop:     jsr getcontrols
                lda joystick
                cmp heronextmove
                bne r_notcorrectmove
                lda #$00
                sta heroidle
                lda heronextmove
                eor #JOY_LEFT+JOY_RIGHT
                sta heronextmove
                lda heromouth
                eor #$01
                sta heromouth

                lda womantime                   ;If not speaking at the
                bne r_noscore                   ;same time, earn points
                ldx #0
                ldy #$50
                jsr addscore
r_noscore:


                ldy herostringptr
                lda textscreen+10*40+17
                sta textscreen+10*40+18
                lda textscreen+10*40+16
                sta textscreen+10*40+17
                lda textscreen+10*40+15
                sta textscreen+10*40+16
                lda textscreen+10*40+14
                sta textscreen+10*40+15
                lda textscreen+10*40+13
                sta textscreen+10*40+14
                lda herostring,y
                and #$3f
                ora #$80
                sta textscreen+10*40+13
                iny
                cpy #$03
                bne r_hstringnotover
                ldy #$00
r_hstringnotover:sty herostringptr
                jmp r_herodone
r_notcorrectmove:
                lda heroidle
                cmp #8
                bcc r_heroidlenotmax
                lda #$a0
                sta textscreen+10*40+13
                sta textscreen+10*40+14
                sta textscreen+10*40+15
                sta textscreen+10*40+16
                sta textscreen+10*40+17
                sta textscreen+10*40+18
                lda #$00
                sta heroidle
                sta heromouth
                sta herostringptr
r_heroidlenotmax:inc heroidle
r_herodone:

                lda womantime
                bne r_womannotidle
                jsr random
                cmp #$05
                bcs r_womannotidle
                jsr random
                and #$0f
                adc #10
                sta womantime
r_womannotidle: lda womantime
                beq r_womanidle
                lda womanidle
                cmp #$02                        ;Some delay
                bcc r_womanidle
                dec womantime
                lda #$00
                sta womanidle
                lda womanmouth
                eor #$01
                sta womanmouth

                lda joystick                            ;Is the hero
                and #JOY_FIRE                           ;listening?
                beq r_notlisten
                ldx #$00
                ldy #$30
                jsr addscore
r_notlisten:

                ldy womanstringptr
                lda textscreen+7*40+21
                sta textscreen+7*40+20
                lda textscreen+7*40+22
                sta textscreen+7*40+21
                lda textscreen+7*40+23
                sta textscreen+7*40+22
                lda textscreen+7*40+24
                sta textscreen+7*40+23
                lda textscreen+7*40+25
                sta textscreen+7*40+24
                lda womanstring,y
                and #$3f
                ora #$80
                sta textscreen+7*40+25
                iny
                cpy #$03
                bne r_wstringnotover
                ldy #$00
r_wstringnotover:sty womanstringptr
                jmp r_womandone
r_womanidle:    lda womanidle
                cmp #8
                bcc r_womanidlenotmax
                lda #$a0
                sta textscreen+7*40+20
                sta textscreen+7*40+21
                sta textscreen+7*40+22
                sta textscreen+7*40+23
                sta textscreen+7*40+24
                sta textscreen+7*40+25
                lda #$00
                sta womanidle
                sta womanmouth
                sta womanstringptr
r_womanidlenotmax:inc womanidle
r_womandone:
                inc timecounter
                lda timecounter
                cmp #$06
                bcc r_notimedec
                lda #$00
                sta timecounter
                dec time
r_notimedec:

                lda #153
                clc
                adc heromouth
                sta spritef
                lda #155
                clc
                adc womanmouth
                sta spritef+1

                jsr drawsprites
                jsr updatepanel
                ldy #$04
                jsr fixeddelay
                jsr delay
                lda time
                beq r_proceed
                jmp r_mainloop

r_proceed:      jmp nextlevel

herostring:     dc.b "ALB"
womanstring:    dc.b "BLA"

heromouth:      dc.b 0
heroidle:       dc.b 0
heronextmove:   dc.b 0
herostringptr:  dc.b 0

womanmouth:     dc.b 0
womanidle:      dc.b 0
womantime:      dc.b 0
womanstringptr: dc.b 0
timecounter:    dc.b 0




beatemup:       lda #14
                jsr cleartextscreen
                lda #6
                ldx #9
be_bg1:         jsr setrowcolor
                inx
                cpx #14
                bcc be_bg1
                lda #8
be_bg2:         jsr setrowcolor
                inx
                cpx #20
                bcc be_bg2
                ldx #120
be_makeground:  jsr random
                and #$07
                cmp #6
                bcs be_makeground
                adc #14
                tay
                asl
                asl
                asl
                sta temp3
                lda screenrowtbllo,y
                sta temp1
                lda screenrowtblhi,y
                ora #>textscreen
                sta temp2
be_makeground2: jsr random
                cmp temp3
                bcs be_skipbg
                jsr random
                and #63
                cmp #40
                bcs be_makeground2
                tay
                lda #127
                sta (temp1),y
be_skipbg:      dex
                bne be_makeground
                jsr clearsprites
                lda #$ff
                sta $d017               ;Y & X-expand for all sprites
                sta $d01d

                lda #40
                sta spritex
                sta spritex+1
                lda #120
                sta spritex+2
                sta spritex+3
                lda #102
                sta spritey
                sta spritey+2
                lda #144
                sta spritey+1
                sta spritey+3

                lda #10
                sta spritec
                sta spritec+1
                sta spritec+2
                lda #11
                sta spritec+3
                lda #0
                sta heroframe
                sta badguyframe
                sta heroattack
                sta badguyattack
                sta herohit
                sta badguyhit

be_mainloop:    jsr getcontrols

                lda herohit
                beq be_heronothit
                lda spritex
                eor #$01
                sta spritex
                sta spritex+1
                dec herohit
                jmp be_skipheromove
be_heronothit:
                lda heroattack
                beq be_heromoveok
                dec heroattack
                bne be_heroattacknotover
                lda #1
                sta heroframe
be_heroattacknotover:
                jmp be_skipheromove
be_heromoveok:  lda joystick
                and #JOY_LEFT
                beq be_notleft
                lda spritex
                sec
                sbc #5
                sta spritex
                sta spritex+1
                lda heroframe
                and #$01
                eor #$01
                sta heroframe
be_notleft:     lda joystick
                and #JOY_RIGHT
                beq be_notright
                lda spritex
                clc
                adc #5
                sta spritex
                sta spritex+1
                lda heroframe
                and #$01
                eor #$01
                sta heroframe
be_notright:    lda joystick
                and #JOY_UP
                beq be_notup
                lda #2
                sta heroframe
                lda #5
                sta heroattack
                lda spritex+2
                sec
                sbc spritex
                cmp #20
                bcs be_nodamage1
                lda badguyenergy
                sec
                sbc #5
                sta badguyenergy
                bcs be_notzero1
                lda #0
                sta badguyenergy
be_notzero1:    lda #3
                sta badguyhit
                ldx #$04
                ldy #$00
                jsr addscore
be_nodamage1:
be_notup:       lda joystick
                and #JOY_DOWN
                beq be_notdown
                lda #3
                sta heroframe
                lda #8
                sta heroattack
                lda spritex+2
                sec
                sbc spritex
                cmp #20
                bcs be_nodamage2
                lda badguyenergy
                sec
                sbc #8
                sta badguyenergy
                bcs be_notzero2
                lda #0
                sta badguyenergy
be_notzero2:    lda #3
                sta badguyhit
                ldx #$06
                ldy #$00
                jsr addscore
be_nodamage2:
be_notdown:
be_skipheromove:

                lda badguyhit
                beq be_badguynothit
                lda spritex+2
                eor #$01
                sta spritex+2
                sta spritex+3
                dec badguyhit
                jmp be_skipbadguymove
be_badguynothit:

                lda badguyattack
                beq be_badguymoveok
                dec badguyattack
                bne be_badguyattacknotover
                lda #1
                sta badguyframe
be_badguyattacknotover:
                jmp be_skipbadguymove
be_badguymoveok:lda spritex+2
                cmp spritex
                bcc be_goright
                lda spritex+2
                sec
                sbc spritex
                cmp #20
                bcc be_bnotleft
                jsr random
                cmp #$80
                bcs be_bnotleft
                lda spritex+2
                sec
                sbc #4
                sta spritex+2
                sta spritex+3
                lda badguyframe
                and #$01
                eor #$01
                sta badguyframe
                jmp be_skipbadguymove
be_bnotleft:    lda spritex+2
                sec
                sbc spritex
                cmp #15
                bcs be_bnotright
                jsr random
                cmp #$c0
                bcs be_bnotright
be_goright:     lda spritex+2
                clc
                adc #4
                sta spritex+2
                sta spritex+3
                lda badguyframe
                and #$01
                eor #$01
                sta badguyframe
                jmp be_skipbadguymove
be_bnotright:   lda spritex+2
                sec
                sbc spritex
                cmp #25
                bcs be_bnotup
                jsr random
                cmp #$20
                bcs be_bnotup
                lda #2
                sta badguyframe
                lda #5
                sta badguyattack
                lda spritex+2
                sec
                sbc spritex
                cmp #20
                bcs be_bnodamage1
                lda #5
                jsr plrdamage
                lda #3
                sta herohit
                ldx #$02
                ldy #$00
                jsr addscore
be_bnodamage1:  jmp be_skipbadguymove
be_bnotup:      lda spritex+2
                sec
                sbc spritex
                cmp #25
                bcs be_bnotdown
                jsr random
                cmp #$18
                bcs be_bnotdown
                lda #3
                sta badguyframe
                lda #8
                sta badguyattack
                lda spritex+2
                sec
                sbc spritex
                cmp #20
                bcs be_bnodamage2
                lda #8
                jsr plrdamage
                lda #3
                sta herohit
                ldx #$03
                ldy #$00
                jsr addscore
be_bnodamage2:
be_bnotdown:
be_skipbadguymove:

                lda heroframe
                asl
                adc #157
                sta spritef
                adc #$01
                sta spritef+1
                lda badguyframe
                asl
                adc #165
                sta spritef+2
                adc #$01
                sta spritef+3
                jsr drawsprites
                jsr updatepanel
                ldy #4
                jsr fixeddelay
                jsr delay
                jsr delay
                lda energy
                beq be_death
                lda badguyenergy
                beq be_victory
                jmp be_mainloop

be_death:       inc spritec
                inc spritec+1
                jsr drawsprites
                jsr updatepanel
                ldy #$02
                jsr fixeddelay
                lda spritec
                bne be_death
                jmp gameover

be_victory:     sed
                lda #$05
                clc
                adc score+2
                sta score+2
                cld
                lda #-3
                sta spritesy+2
                sta spritesy+3
                lda #1
                sta spritesx+2
                sta spritesx+3
be_victory1:    jsr movesprites
                jsr drawsprites
                jsr updatepanel
                ldy #$0c
                jsr fixeddelay
                lda spritey+2
                cmp #50
                bcs be_victory1
                lda #$03
                sta $d017               ;Y & X-expand for hero only
                sta $d01d
                lda spritey+2
                clc
                adc #21
                sta spritey+3
                lda #2
                sta spritesy+2
                sta spritesy+3
be_victory2:    jsr movesprites
                jsr drawsprites
                jsr updatepanel
                ldy #$0c
                jsr fixeddelay
                lda spritey+2
                cmp #120
                bcc be_victory2
                lda #$00
                sta spritef+2
                sta spritef+3
                jsr drawsprites
                jsr countenergybonus
                jmp nextlevel

heroframe:      dc.b 0
heroattack:     dc.b 0
herohit:        dc.b 0
badguyframe:    dc.b 0
badguyattack:   dc.b 0
badguyhit:      dc.b 0

nextlevel:      inc level
                jmp levelbegin

aftervictory:   lda delayvalue
                sec
                sbc #12
                sta delayvalue
                lda #0
                sta level
                jmp levelbegin

countenergybonus:
                lda energy
                beq ceb_done
                dec energy
                ldx #0
                ldy #$50
                jsr addscore
                ldy #$0a
                jsr fixeddelay
                jsr updatepanel
                jmp countenergybonus
ceb_done:       rts

checkbulletcollision:
                lda spritex,x
                sec
                sbc spritex,y
                bpl cbcxcollok
                eor #$ff
                adc #$01
cbcxcollok:     cmp #10
                bcs cbcnocollision
                lda spritey,x
                sec
                sbc spritey,y
                bpl cbcycollok
                eor #$ff
                adc #$01
cbcycollok:     cmp #8
                bcs cbcnocollision
cbcnocollision: rts

addscore:       sed
                tya
                clc
                adc score
                sta score
                txa
                adc score+1
                sta score+1
                lda #$00
                adc score+2
                sta score+2
                cld
                rts

plrdamage:      sta plrdmg_sbc+1
                lda energy
                sec
plrdmg_sbc:     sbc #$00
                bcs plrdmg_ok
                lda #$00
plrdmg_ok:      sta energy
                rts

random:         lda #$00
                eor $d012
random1:        adc #$39
                rol
                bcc random3
random2:        sbc #$7b
random3:        sta random+1
                pha
                lda random1+1
                adc #$53
                sta random1+1
                lda random2+1
                adc #$3d
                sta random2+1
                pla
                rts

movesprites:    ldx #$07
msprloop:       lda spritef,x
                beq mspr_skip
                lda spritex,x
                clc
                adc spritesx,x
                sta spritex,x
                lda spritey,x
                clc
                adc spritesy,x
                sta spritey,x
mspr_skip:      dex
                bpl msprloop
                rts

clearsprites:   ldx #$07
csprloop:       lda #$00
                sta spritef,x
                sta spritesx,x
                sta spritesy,x
                dex
                bpl csprloop
                rts

drawsprites:    lda #$00
                sta $d015
                ldx #$07
                ldy #$0e
dsprloop:       lda spritef,x
                beq dspr_skip
                lda spritex,x
                asl
                sta $d000,y
                bcs dspr_highx
                lda $d010
                and sprandbit,x
                sta $d010
                jmp dspr_xok
dspr_highx:     lda $d010
                ora sprorbit,x
                sta $d010
dspr_xok:       lda spritey,x
                sta $d001,y
                lda spritef,x
                sta $7f8,x
                lda spritec,x
                sta $d027,x
                lda $d015
                ora sprorbit,x
                sta $d015
dspr_skip:      dey
                dey
                dex
                bpl dsprloop
                rts

getcharundersprite:
                lda spritey,x
                sec
                sbc #50-21
                bcs gcus_ok
                lda #0
gcus_ok:        cmp #159
                bcc gcus_ok2
                lda #159
gcus_ok2:       lsr
                lsr
                lsr
                tay
                lda screenrowtbllo,y
                sta temp1
                lda screenrowtblhi,y
                ora #>textscreen
                sta temp2
                lda spritex,x
                sec
                sbc #12-6
                lsr
                lsr
                cmp #40
                bcs gcus_outside
                tay
                lda (temp1),y
                rts
gcus_outside:   lda #32
                rts

spritex:        ds.b 8,0
spritey:        ds.b 8,0
spritef:        ds.b 8,0
spritec:        ds.b 8,0
spritesx:       ds.b 8,0
spritesy:       ds.b 8,0
spritet:        ds.b 8,0
sprited:        ds.b 8,0

sprorbit:       dc.b 1,2,4,8,16,32,64,128
sprandbit:      dc.b 255-1,255-2,255-4,255-8,255-16,255-32,255-64,255-128

delay:          ldy delayvalue
fixeddelay:     ldx #$00
delay1:         dex
                bne delay1
                dey
                bne delay1
                rts

longdelay:      ldy #$ff
                jsr fixeddelay
                sec
                sbc #$01
                bne longdelay
                rts

waitfire:       jsr getcontrols
                lda prevjoy
                and #JOY_FIRE
                bne waitfire
                lda joystick
                and #JOY_FIRE
                beq waitfire
                rts

initpanel:      ldx #20
iploop:         lda #$0b
                jsr setrowcolor
                lda #$20
                jsr setrowchar
                inx
                cpx #25
                bcc iploop
                lda #79
                sta textscreen+20*40
                lda #80
                sta textscreen+20*40+39
                lda #76
                sta textscreen+24*40
                lda #122
                sta textscreen+24*40+39
                ldx #38
iploopx:        lda #119
                sta textscreen+20*40,x
                lda #111
                sta textscreen+24*40,x
                dex
                bne iploopx
                lda #101
                sta textscreen+21*40
                sta textscreen+22*40
                sta textscreen+23*40
                lda #106
                sta textscreen+21*40+39
                sta textscreen+22*40+39
                sta textscreen+23*40+39
                lda #<scoretext
                sta textptrlo
                lda #>scoretext
                sta textptrhi
                lda #7
                sta textcolor
                ldx #1
                ldy #21
                jsr printtext
                iny
                iny
                jsr printtext
                ldx #17
                ldy #21
                jsr printtext
                lda level
                asl
                adc level
                asl
                adc textptrlo
                sta textptrlo
                lda textptrhi
                adc #$00
                sta textptrhi
                iny
                iny
                jsr printtext
                lda #$01
                ldx #5
iploop2:        sta colors+21*40+9,x
                sta colors+23*40+9,x
                dex
                bpl iploop2
                lda #$05
                ldx #15
iploop3:        sta colors+21*40+23,x
                sta colors+23*40+23,x
                cpx #04
                bcs ipskip
                lda #$02
ipskip:         dex
                bpl iploop3
updatepanel:    lda score+2
                jsr converttodigits
                stx textscreen+21*40+9
                sty textscreen+21*40+10
                lda hiscore+2
                jsr converttodigits
                stx textscreen+23*40+9
                sty textscreen+23*40+10
                lda score+1
                jsr converttodigits
                stx textscreen+21*40+11
                sty textscreen+21*40+12
                lda hiscore+1
                jsr converttodigits
                stx textscreen+23*40+11
                sty textscreen+23*40+12
                lda score
                jsr converttodigits
                stx textscreen+21*40+13
                sty textscreen+21*40+14
                lda hiscore
                jsr converttodigits
                stx textscreen+23*40+13
                sty textscreen+23*40+14
                ldy energy
                ldx #1*40+23
                jsr drawmeter
                ldx level
                ldy dist,x
                ldx #3*40+23

drawmeter:      tya
                lsr
                lsr
                lsr
                tay
                lda #$10
                sta temp1
                lda #$a0
dmloop:         dey
                bpl dmskip
                lda #$20
dmskip:         sta textscreen+20*40,x
                inx
                dec temp1
                bne dmloop
                rts

converttodigits:pha
                lsr
                lsr
                lsr
                lsr
                ora #$30
                tax
                pla
                and #$0f
                ora #$30
                tay
                rts

;Ŀ
;PRINTTEXTC                                                                   
;                                                                             
;Centered text printing                                                       
;                                                                             
;Parameters: Y:row textptr:address of text                                    
;Returns: -                                                                   
;Modifies: A,X,textptr,temp1-temp2,temp6                                      
;

printtextc:     sty temp6
                ldy #$00
                ldx #40
ptc_getlen:     lda (textptrlo),y
                beq ptc_ready
                dex
                iny
                bne ptc_getlen
ptc_ready:      txa
                lsr
                tax
                ldy temp6

;Ŀ
;PRINTTEXT                                                                    
;                                                                             
;Prints a zero-terminated string                                              
;                                                                             
;Parameters: X,Y, textptr:Address of text                                     
;Returns: -                                                                   
;Modifies: A,temppptr,temp1-temp4,temp6                                       
;

printtext:      sty temp6
                txa
                clc
                adc screenrowtbllo,y
                sta temp1
                sta temp3
                lda #>textscreen
                adc screenrowtblhi,y
                sta temp2
                lda screenrowtblhi,y
                ora #>colors
                sta temp4
                ldy #$00
pt_printloop:   lda (textptrlo),y
                beq pt_printend
                and #$3f
                sta (temp1),y
                lda textcolor
                sta (temp3),y
                iny
                jmp pt_printloop
pt_printend:    tya
                sec                             ;Add one more; INY not needed
                adc textptrlo
                sta textptrlo
                bcc pt_notover3
                inc textptrhi
pt_notover3:    ldy temp6
                rts

;Ŀ
;CLEARTEXTSCREEN                                                              
;                                                                             
;Clears the upmost 20 rows of the text screen.                                
;                                                                             
;Parameters: A:Color to be used                                               
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

cleartextscreen:sta ctsloop1+1
                ldx #$00
                stx $d015
ctsloop1:       lda #$00
                jsr setrowcolor
                inx
                cpx #20
                bcc ctsloop1
                ldx #$00
ctsloop2:       lda #$a0
                jsr setrowchar
                inx
                cpx #20
                bcc ctsloop2
                rts

;Ŀ
;SETROWCHAR                                                                   
;                                                                             
;Sets all characters on a textscreen row                                      
;                                                                             
;Parameters: X:Row number A:Char number                                       
;Returns: -                                                                   
;Modifies: Y                                                                  
;

setrowchar:     tay
                lda #>textscreen
setrowcommon:   ora screenrowtblhi,x
                sta setrowcharloop+2
                lda screenrowtbllo,x
                sta setrowcharloop+1
                tya
                ldy #39
setrowcharloop: sta $1000,y
                dey
                bpl setrowcharloop
                rts

;Ŀ
;SETROWCOLOR                                                                  
;                                                                             
;Sets color of all characters on a textscreen row.                            
;                                                                             
;Parameters: X:Row number A:Char number                                       
;Returns: -                                                                   
;Modifies: Y                                                                  
;

setrowcolor:    tay
                lda #>colors
                bne setrowcommon

getcontrols:    lda #$ff
                sta $dc00
                lda joystick
                sta prevjoy
                lda $dc00
                eor #$ff
                sta joystick
                rts

initvideo:      lda #$00
                sta $d020
                sta $d021
                lda $dd00
                and #$fc
                ora #$03
                sta $dd00
                lda #21
                sta $d018
                lda #200
                sta $d016
                lda #27
                sta $d011
                lda #$ff                        ;All sprites multicolor
                sta $d01c
                lda #$00                        ;Set sprite multicolors
                sta $d025
                lda #$0f
                sta $d026
                rts

initirq:        sei
                lda #$7f                        ;Set timer interrupt off
                sta $dc0d
                lda #$01                        ;Set raster interrupt on
                sta $d01a
                lda #$fc                        ;Set low bits of position
                sta $d012                       ;for first raster interrupt
                lda #<musicplayer
                sta $0314
                lda #>musicplayer
                sta $0315
                lda #$00
                jsr music
                lda $dc0d                       ;Acknowledge timer interrupt
                cli                             ;(for safety)
                rts


;Ŀ
;IRQ ROUTINE                                                                             
;

musicplayer:    cld
                inc $d019
                jsr music+3
                jmp $ea31

screenrowtbllo:
N               SET 0
                REPEAT 25
                dc.b #<(N*40)
N               SET N+1
                REPEND
screenrowtblhi:
N               SET 0
                REPEAT 25
                dc.b #>(N*40)
N               SET N+1
                REPEND

briefingptr:    dc.w level1text
                dc.w level2text
                dc.w level3text
                dc.w level4text
                dc.w victorytext

leveljumptbl:   dc.w carchase
                dc.w gunfight
                dc.w romance
                dc.w beatemup
                dc.w aftervictory

text1:          dc.b "CADAVER PRESENTS:",0
text2:          dc.b "ADVANCED ACTION MOVIE SIMULATOR",0
text3:          dc.b "PRESS FIRE ON JOYSTICK 2",0

level1text:     dc.b "LEVEL 1 - CAR CHASE SCENE",0
                     ;0123456789012345678901234567890123456789
                dc.b "CHASED BY BOTH THE BAD GUY(TM)'S" ,0
                dc.b "HENCHMEN AND THE POLICE, YOU SPEED",0
                dc.b "AWAY FROM THEM!",0

level2text:     dc.b "LEVEL 2 - THE GUNFIGHT SCENE",0
                dc.b "YOU REALIZE THERE IS NO ESCAPE FROM",0
                dc.b "THE BAD GUY(TM)'S ARMY. INSTEAD, FIGHT",0
                dc.b "THEM WITH BOTH GUNS BLAZING!",0

level3text:     dc.b "LEVEL 3 - ROMANTIC SCENE",0
                dc.b "EARN BONUSES BY CONFESSING YOUR TRAUMAS",0
                dc.b "TO THE LOVE INTEREST(TM). BUT THE TRUE",0
                dc.b "ACTION HERO KNOWS ALSO HOW TO LISTEN!",0

level4text:     dc.b "LEVEL 4 - FINAL SHOWDOWN SCENE",0
                dc.b "FINAL CONFLICT TAKES THE FORM OF HAND-",0
                dc.b "TO-HAND COMBAT WITH THE BAD GUY(TM).",0
                dc.b "FOR BONUSES, ALLOW YOURSELF TO BE HIT!",0

victorytext:    dc.b "CONGRATULATIONS!",0
                dc.b "YOU KICKED BAD GUY(TM)'S ASS, SAVED",0
                dc.b "THE WORLD, GOT THE GIRL ETC. ETC. ETC.",0
                dc.b "TRY AGAIN, IT WILL BE FASTER!",0

continuetext:   dc.b "PRESS FIRE TO CONTINUE",0

gameovertext:   dc.b "GAME OVER",0

scoretext:      dc.b "  SCORE",0
hiscoretext:    dc.b "HISCORE",0
energytext1:    dc.b " HERO",0
levelstattext1: dc.b " DIST",0
levelstattext2: dc.b "ENEMY",0
levelstattext3: dc.b " TIME",0
levelstattext4: dc.b "ENEMY",0

level:          dc.b 1
score:          dc.b 0,0,0
hiscore:        dc.b 0,0,0
energy:         dc.b 128
dist:           dc.b 128
enemy:          dc.b 128
time:           dc.b 128
badguyenergy:   dc.b 128

joystick:       dc.b 0
prevjoy:        dc.b 0
delayvalue:     dc.b 0
roadcounter:    dc.b 0
distcounter:    dc.b 0

                org sprites

                incbin aams.spr

                org music

                incbin music.bin
